SystemOrganization addCategory: #'BlobFollower-Etoys'!

Player subclass: #BlobFollowerPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Etoys'!

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 17:15'!
getBlobFound
	^ self getValueFromCostume: #blobFound! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:56'!
getBlobX
	^ self getValueFromCostume: #blobX! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:56'!
getBlobY
	^ self getValueFromCostume: #blobY! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getBrightnessMargin
	^ self getValueFromCostume: #brightnessMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 17:33'!
getFps
	^ self getValueFromCostume: #fps! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getHueMargin
	^ self getValueFromCostume: #hueMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getSaturationMargin
	^ self getValueFromCostume: #saturationMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getSource
	^ self getValueFromCostume: #source! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getTrackedColor
	^ self getValueFromCostume: #trackedColor! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
setBrightnessMargin: value
	^ self setCostumeSlot: #brightnessMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
setHueMargin: value
	^ self setCostumeSlot: #hueMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:30'!
setSaturationMargin: value
	^ self setCostumeSlot: #saturationMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:31'!
setSource: aPlayer
	^ self setCostumeSlot: #source: toValue: aPlayer costume renderedMorph! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:30'!
setTrackedColor: value
	^ self setCostumeSlot: #trackedColor: toValue: value! !

RectangleMorph subclass: #BlobFollowerMorph
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Etoys'!

!BlobFollowerMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/18/2012 17:33'!
additionsToViewerCategories
	^ # ((blob (
(slot source '' Player readWrite Player getSource Player setSource:)
(slot trackedColor '' Color readWrite Player getTrackedColor Player setTrackedColor:)
(slot hueMargin '' Number readWrite Player getHueMargin Player setHueMargin:)
(slot saturationMargin '' Number readWrite Player getSaturationMargin Player setSaturationMargin:)
(slot brightnessMargin '' Number readWrite Player getBrightnessMargin Player setBrightnessMargin:)
(slot blobX '' Number readOnly Player getBlobX unused unused)
(slot blobY '' Number readOnly Player getBlobY unused unused)
(slot blobFound '' Boolean readOnly Player getBlobFound unused unused)
(slot fps '' Number readOnly Player getFps unused unused)
)))
! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:17'!
blobFound
	^ analyzer ifNil: [false] ifNotNil: [:a | a blobFound]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 16:57'!
blobX
	^ self center x - self source left / self source width! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 16:57'!
blobY
	^ self source bottom - self center y / self source height! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
brightnessMargin
	^ analyzer 
		ifNil: [0.2]
		ifNotNil: [:a | a brightnessMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:46'!
brightnessMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: self hueMargin
		s: self saturationMargin
		v: aNumber! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:33'!
fps
	^ analyzer ifNil: [0] ifNotNil: [:a | a fps]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
hueMargin
	^ analyzer 
		ifNil: [20]
		ifNotNil: [:a | a hueMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
hueMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: aNumber
		s: self saturationMargin
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'initialization' stamp: 'Richo 9/18/2012 15:48'!
initialize
	super initialize.
	self color: Color transparent! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 16:25'!
newPlayerInstance
	^ BlobFollowerPlayer newUserInstance! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
saturationMargin
	^ analyzer 
		ifNil: [0.2]
		ifNotNil: [:a | a saturationMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
saturationMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: self hueMargin
		s: aNumber
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
source
	^ analyzer 
		ifNil: [World]
		ifNotNil: [:a | a source]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
source: aMorph
	analyzer := ImageAnalyzer
		on: aMorph
		track: self trackedColor
		h: self hueMargin
		s: self saturationMargin
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'stepping' stamp: 'Richo 9/18/2012 16:33'!
step
	analyzer ifNil: [^ self].
	self source isInWorld ifFalse: [^ self].
	self isInWorld ifFalse: [^ self].
	self bounds: (analyzer track translateBy: self source topLeft)! !

!BlobFollowerMorph methodsFor: 'stepping' stamp: 'Richo 9/18/2012 15:53'!
stepTime
	^ 1! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
trackedColor
	^ analyzer 
		ifNil: [Color blue]
		ifNotNil: [:a | a trackedColor]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
trackedColor: aColor
	analyzer := ImageAnalyzer
		on: self source
		track: aColor
		h: self hueMargin
		s: self saturationMargin
		v: self brightnessMargin! !
